/*
 * spi.c
 *
 * Created: 31.08.2012 16:09:22
 *  Author: ls4446s
 */ 

#include <avr/interrupt.h>
#include "spi.h"

void SPI_MasterInit()
{
	// set MOSI, SS and SCK output, all others input
	DDR_SPI=(1<<DD_MOSI)|(1<<DD_SCK)|(1<<DD_SS);
	// enable SPI, Master, set clock rate fck/16
	SPCR=(1<<SPE)|(1<<MSTR)|(1<<SPR0);
	SS_high();
}

void SPI_SlaveInit()
{
	// set MISO output, all other input
	DDR_SPI=(1<<DD_MISO);
	// enable SPI
	SPCR=(1<<SPE);
	// clear SPI Interrupt Flag by reading SPSR and SPDR
	uint8_t c=SPSR;
	c=SPDR;
}

// verschachtelung von SPI_MasterTransmit und SPI_TransmitAndReceive
// nach Zweckmigkeit untersuchen...
char SPI_TransmitAndReceive(char cData)
{
	// start transmission
	SPDR=cData;
	// wait for transmission complete
	while(!(SPSR&(1<<SPIF)))
		;
	return SPDR;
}

char SPI_MasterTransmit(char cData)
{
	char rData;
	SS_low();
	rData=SPI_TransmitAndReceive(cData);
	SS_high();
	return rData;
}

uint8_t SPI_SlaveReceive(void)
{
	
	// wait for reception complete
	while (!(SPSR&(1<<SPIF)))
		;
	return SPDR;
}