/*
 * spi.h
 *
 * Created: 31.08.2012 16:09:37
 *  Author: ls4446s
 */ 


#ifndef SPI_H_
#define SPI_H_
#include <avr/io.h>

#define DDR_SPI		DDRB
#define PORT_SPI	PORTB
#define DD_MOSI		PB2
#define DD_SCK		PB1
#define DD_MISO		PB3
#define DD_SS		PB0

#define SS_high(void)	PORT_SPI|=(1<<DD_SS);
#define SS_low(void)	PORT_SPI&=~(1<<DD_SS);

void SPI_MasterInit(void);
void SPI_SlaveInit(void);
char SPI_TransmitAndReceive(char cData);

char SPI_MasterTransmit(char cData);
uint8_t SPI_SlaveReceive(void);

#endif /* SPI_H_ */